=== python/requirements.txt ===
numpy>=1.11.0
pyparsing>=2.4.2
