=== timing/CMakeLists.txt ===
gtsamAddTimingGlob("*.cpp" "" "gtsam")

target_link_libraries(timeGaussianFactorGraph CppUnitLite)
