=== debian/changelog ===
gtsam (4.2.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * d/watch: version=5
  * Remove libboost-system-dev from Build-Depends
    Closes: #1127208
  * Standards-Version: 4.7.3 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/control (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * dh_missing --list-missing since Python interface is not installed

 -- Andreas Tille <tille@debian.org>  Wed, 18 Feb 2026 07:05:21 +0100

gtsam (4.2.0+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Dima Kogan ]
  * d/control: Fix Homepage field.

  [ Adrian Bunk ]
  * Backport upstream fix for FTBFS with CMake 4. Closes: #1112982.

  [ Santiago Vila ]
  * d/control: Drop "Priority: optional" (default).
  * d/control: Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Thu, 20 Nov 2025 07:50:00 +0100
