=== debian/watch ===
Version: 5

Source: https://github.com/borglab/gtsam/tags
Matching-Pattern: (?:.*?/)?v?(\d[\d.]+)@ARCHIVE_EXT@
Dversion-Mangle: auto
Repack-Suffix: +dfsg
Uversion-Mangle: s/a([0-9])/~$1/
